// ptrlist1.C - STL list container with pointer semantics, user destroy()
#include <iostream.h>
#include <list>
#include "Shape.h"

using namespace std;

void build_list(list<Shape *> &);
void shape_info(const list<Shape *> &);

//template <class Container>
//void destroy_objects(Container &);
void destroy_objects(list<Shape *> &);

int main() 
{
	list<Shape *> shapelist;					// Pointer List

	build_list(shapelist);						// build Shape * list
	shape_info(shapelist);						// display Shape data

	delete shapelist.front();					// delete Shape at front
	shapelist.pop_front();						// remove ptr from shapelist
	cout << "There are " << Shape::num_shapes() 
			<< " shapes left" << endl;
	destroy_objects(shapelist);
	return 0;
}

void build_list(list<Shape *> & ls) {
	ls.push_back(new Square(5));
	ls.push_back(new Circle(3));
	ls.push_back(new RTriangle(4, 6));
	cout << "Shape list built with " << 
			Shape::num_shapes() << " shapes" << endl;
}

void shape_info(const list<Shape *> & ls) {
	list<Shape *>::const_iterator iter = ls.begin();
	for (; iter != ls.end(); iter++) {
		cout << "I'm a " << *(*iter) << ", ";
		cout << "area " << (*iter)->area() << " and ";
		cout << "perimeter " << (*iter)->perimeter() << endl;
	}
}

// g++ doesn't take this...
//template <class Container>
//void destroy_objects(Container & c) {
	//Container::iterator iter = c.begin();
	//for (; iter != c.end(); iter++)
		//delete *iter;
//}

void destroy_objects(list<Shape *> & c) {
	list<Shape *>::iterator iter = c.begin();
	for (; iter != c.end(); iter++)
		delete *iter;
}

/******************************************************************

$ ptrlist1
Shape list built with 3 shapes
I'm a Square: side 5, area 25 and perimeter 20
I'm a Circle: radius 3, area 28.2743 and perimeter 18.8496
I'm a RTriangle: height 4, base 6, area 12 and perimeter 17.2111
There are 2 shapes left

*/
