// fsplace - free store placement
#include <iostream.h>
#include <malloc.h>
#include <new.h>

class A {
private:
	int *p;
	int size;
public:
	A(int len = 0) { 
		p = new int[size=len]; 
		cout << "A constr: " << p << endl;
	}
	~A() { 
		cout << "A destr: " << p << endl; 
		delete [] p; 
	}
};

char *spot1 = new char[sizeof(A)];			// new(sizeof(A))
char *spot2 = new char[5*sizeof(A)];		// new[](5*sizeof(A)*sizeof(char))

int main() {
	 A *p = new (spot1) A;					// new(sizeof(A), spot1)
	 A *q = new (spot2) A[5];				// new[](5*sizeof(A), spot2)
	 cout << "p = " << p << "  spot1 = " << (void *)spot1 << endl;
	 cout << "q = " << q << "  spot2 = " << (void *)spot2 << endl;

	 p->~A();									// explicit destructor
	 for (int i = 4; i >= 0; i--)
	 	q[i].~A();								// explict destructor
	 delete [] spot1;							// delete free store placement
	 delete [] spot2;							// delete free store placement
	 return 0;
}

/**********************************************************************

$ fsplace 
A constr: 0x8049e58
A constr: 0x8049e68
A constr: 0x8049e78
A constr: 0x8049e88
A constr: 0x8049e98
A constr: 0x8049ea8
p = 0x8049e18  spot1 = 0x8049e18
q = 0x8049e2c  spot2 = 0x8049e28
A destr: 0x8049e58
A destr: 0x8049ea8
A destr: 0x8049e98
A destr: 0x8049e88
A destr: 0x8049e78
A destr: 0x8049e68

*/
