// sgplace.c - static and global array placement
#include <iostream.h>
#include <malloc.h>
#include <new.h>

class A {
private:
	int *p;
	int size;
public:
	A(int len = 0) { 
		p = new int[size=len]; 
		cout << "A constr: " << p << endl;
	}
	~A() { 
		cout << "A destr: " << p << endl; 
		delete [] p; 
	}
};

char buf1[1024];								// global character buffer
static char buf2[1024];							// static character buffer

int main() {
	 A *p = new (buf1) A;							// new(sizeof(A), buf1)
	 A *q = new (buf2) A[5];						// new[](5*sizeof(A), buf2)
	 cout << "p = " << p << "  buf1 = " << (void *)buf1 << endl;
	 cout << "q = " << q << "  buf2 = " << (void *)buf2 << endl;

	 p->~A();											// explicit destructor
	 for (int i = 4; i >= 0; i--)
	 	q[i].~A();										// explict destructor
	 return 0;
}

/**********************************************************************

$ sgplace 
A constr: 0x804a5c8
A constr: 0x804a5d8
A constr: 0x804a5e8
A constr: 0x804a5f8
A constr: 0x804a608
A constr: 0x804a618
p = 0x8049dc0  buf1 = 0x8049dc0
q = 0x804a1c4  buf2 = 0x804a1c0
A destr: 0x804a5c8
A destr: 0x804a618
A destr: 0x804a608
A destr: 0x804a5f8
A destr: 0x804a5e8
A destr: 0x804a5d8

*/
